/*
  Bear Engine

  Copyright (C) 2005-2008 Julien Jorge, Sebastien Angibaud

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: plee-the-bear@gamned.org

  Please add the tag [Bear] in the subject of your mails.
*/
/**
 * \file collision_event.hpp
 * \brief Base class for collision events.
 * \author Julien Jorge
 */
#ifndef __UNIVERSE_COLLISION_EVENT_HPP__
#define __UNIVERSE_COLLISION_EVENT_HPP__

#include "universe/collision_info.hpp"
#include "universe/class_export.hpp"

namespace bear
{
  namespace universe
  {
    /**
     * \brief Base class for collision events.
     */
    class UNIVERSE_EXPORT collision_event
    {
    public:
      virtual ~collision_event();

      virtual void execute( const collision_info& info, physical_item& self,
                            physical_item& that ) const;

    }; // class collision_event
  } // namespace universe
} // namespace bear

#endif // __UNIVERSE_COLLISION_EVENT_HPP__
