/*
  Plee The Bear

  Copyright (C) 2005-2008 Julien Jorge, Sebastien Angibaud

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

  contact: plee-the-bear@gamned.org

  Please add the tag [PTB] in the subject of your mails.
*/
/**
 * \file enemy_counter.cpp
 * \brief Implementation of the ptb::enemy_counter class.
 * \author Julien Jorge
 */
#include "ptb/enemy_counter.hpp"

/*----------------------------------------------------------------------------*/
unsigned int ptb::enemy_counter::s_instances_count = 0;

/*----------------------------------------------------------------------------*/
/**
 * \brief Constructor.
 */
ptb::enemy_counter::enemy_counter()
{
  ++s_instances_count;
} // enemy_counter::enemy_counter()

/*----------------------------------------------------------------------------*/
/**
 * \brief Destructor.
 */
ptb::enemy_counter::~enemy_counter()
{
  --s_instances_count;
} // enemy_counter::~enemy_counter()
